﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace TDBButton
{
    public partial class Form1 : Form
    {
        private Button btn;
        public Form1()
        {
            InitializeComponent();
            c1TrueDBGrid1.SetDataBinding();
            btn = new Button();
            btn.Image = Resource1.down;
            btn.Visible = false;
            btn.Click += Btn_Click;
            c1TrueDBGrid1.Controls.Add(btn);
            c1TrueDBGrid1.AddRows(10);

            
            c1TrueDBGrid1.Splits[0].DisplayColumns[0].OwnerDraw = true;
            c1TrueDBGrid1.OwnerDrawCell += C1TrueDBGrid1_OwnerDrawCell;
            c1TrueDBGrid1.Scroll += C1TrueDBGrid1_Scroll;
            c1TrueDBGrid1.RowResize += C1TrueDBGrid1_RowResize;
            c1TrueDBGrid1.RowColChange += C1TrueDBGrid1_RowColChange;
            
        }

        private void Btn_Click(object sender, EventArgs e)
        {
            if (btn.Tag is null) return;
            Point data = (Point)btn.Tag;
            MessageBox.Show(string.Format("Row {0}, Col {1}", data.X, data.Y));
        }

        private void C1TrueDBGrid1_OwnerDrawCell(object sender, C1.Win.C1TrueDBGrid.OwnerDrawCellEventArgs e)
        {
            if (e.Col == c1TrueDBGrid1.Col && e.Row == c1TrueDBGrid1.Row) {
                if (e.Col != 0)
                    return;
                btn.Visible = true;
                btn.Tag = new Point(e.Row, e.Col);
                UpdateBtnRect(e.CellRect);
            }
        }

        private void C1TrueDBGrid1_Scroll(object sender, C1.Win.C1TrueDBGrid.CancelEventArgs e)
        {
            btn.Visible = false;
            c1TrueDBGrid1.RefreshCol(0);
        }

       

        private void C1TrueDBGrid1_RowResize(object sender, C1.Win.C1TrueDBGrid.CancelEventArgs e)
        {
            btn.Visible = false;
            c1TrueDBGrid1.RefreshCol(0);
        }

        private void C1TrueDBGrid1_RowColChange(object sender, C1.Win.C1TrueDBGrid.RowColChangeEventArgs e)
        {
            btn.Visible = false;
            c1TrueDBGrid1.RefreshCol(0);
        }

        private void UpdateBtnRect(Rectangle rect) {
            btn.Width = 20;
            btn.Height = rect.Height;
            btn.Location = new Point(rect.X + rect.Width - 20, rect.Y);
        }
    }
}
